SystemOrganization addCategory: #'SOUL-SmalltalkSymbiosis'!

StandardSoulFactory subclass: #SymbiosisFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-SmalltalkSymbiosis'!

!SymbiosisFactory class methodsFor: 'installing' stamp: 'sp 28/10/11 10:53'!
installSymbiosisFactory
	
	self initialize: self new! !

!SymbiosisFactory class methodsFor: 'installing' stamp: 'sp 28/10/11 10:53'!
revertTo: aFactory
	
	self initialize: aFactory.
	LogicStorage reReadAllStorage! !

!SymbiosisFactory methodsFor: 'evaluators' stamp: 'sp 28/10/11 10:53'!
evaluatorForLogicQuery
	
	^EvaluatorForSymbiosis! !

!SymbiosisFactory methodsFor: 'terms' stamp: 'sp 28/10/11 10:53'!
makeMessageTerm
	
	^SymbioticMessageTerm! !

!SymbiosisFactory methodsFor: 'terms' stamp: 'sp 28/10/11 10:53'!
makeResultMessageTerm
	
	^SymbioticResultMessageTerm! !

!SymbiosisFactory methodsFor: 'kernel' stamp: 'sp 28/10/11 10:53'!
makeResults
	
	^SymbioticSOULResults! !

ResultMessageTerm subclass: #SymbioticResultMessageTerm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-SmalltalkSymbiosis'!

!SymbioticResultMessageTerm methodsFor: 'resolving' stamp: 'AndyKellens 11/2/2011 09:53'!
clauseNotFoundIn: repository inEnv: env startAt: anIndex
	
	| resolveBlock result receiver arguments resolverArgs |
	receiver := messageTerm termSequence terms first soulDownIn: env startAt:
			anIndex.
	arguments := (messageTerm termSequence terms allButFirst: 1) asArray
		collect: [:term | term soulDownIn: env startAt: anIndex].
	(receiver class canUnderstand: messageTerm functor messageSelector)
		ifFalse:
			[self
				error:
					messageTerm functor asString ,
							' is not implemented as a rule nor is understood as a message by instances of '
						, receiver class name asString].
	result := receiver
		perform: messageTerm functor messageSelector
		withArguments: arguments.	"TODO: yuk, type test"

	resolverArgs := (result isKindOf: OrderedCollection)
		ifTrue: [result]
		ifFalse: [OrderedCollection with: result].
	resolveBlock := [:arg | 
	(resultTerm
		unifyWith: arg soulUp
		inEnv: env
		myIndex: anIndex
		hisIndex: (env startUnify: 0)
		inSource: false)
		ifFalse:
			[env rollback.
			nil]
		ifTrue:
			[ResolutionResult
				condition: SoulFactory current makeTermSequence new
				rollbackInfo: env rollbackInfo
				conditionsEnvIndex: nil
				cutState: false]].
	^NativeResolver onBlock: resolveBlock withArguments: resolverArgs! !

Compiler subclass: #SymbiosisCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-SmalltalkSymbiosis'!

!SymbiosisCompiler methodsFor: 'compilation' stamp: 'AndyKellens 10/28/2011 14:53'!
compile: aCode in: aClass classified: aCategory notifying: aRequestor ifFail: aFailBlock
	
	| method |
	method := RBParser parseMethod: aCode.
	(RBReadBeforeWrittenTester variablesReadBeforeWrittenIn: method)
		do:
			[:temp | 
			method body
				addNodeFirst:
					(RBParser parseExpression: temp , ' := UninitializedTemporary new.')].
	^super
		compile: method formattedCode
		in: aClass
		classified: aCategory
		notifying: aRequestor
		ifFail: aFailBlock! !

!SymbiosisCompiler methodsFor: 'compilation' stamp: 'AndyKellens 10/28/2011 13:52'!
compile: aCode in: aClass notifying: aRequestor ifFail: aFailBlock
	
	| method |
	method := RBParser parseMethod: aCode.
	(RBReadBeforeWrittenTester variablesReadBeforeWrittenIn: method)
		do:
			[:temp | 
			method body
				addNodeFirst:
					(RBParser parseExpression: temp , ' := UninitializedTemporary new.')].
	^super
		compile: method formattedCode
		in: aClass
		notifying: aRequestor
		ifFail: aFailBlock! !

Results subclass: #SymbioticSOULResults
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-SmalltalkSymbiosis'!

!SymbioticSOULResults methodsFor: 'public access' stamp: 'sp 28/10/11 10:53'!
downedResultsForVariableNamed: aString
	
	| collection |
	collection := super downedResultsForVariableNamed: aString.
	^collection size = 1
		ifTrue: [FakeSingleItemCollection on: collection first]
		ifFalse:
			[(collection allSatisfy: [:element | element == true])
				ifTrue: [true]
				ifFalse: [collection]]! !

MessageTerm subclass: #SymbioticMessageTerm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-SmalltalkSymbiosis'!

!SymbioticMessageTerm methodsFor: 'resolving' stamp: 'sp 28/10/11 10:53'!
clauseNotFoundIn: repository inEnv: env startAt: anIndex
	
	| resolveBlock |
	resolveBlock := [:uselessArg | 
	| receiver |
	receiver := termsequence terms first soulDownIn: env startAt: anIndex.
	(receiver isKindOf: Variable)
		ifTrue:
			[self smalltalkMessageResolveWithUnknownReceiverIn: env startAt: anIndex]
		ifFalse:
			[self smalltalkMessageResolveWithKnownReceiverIn: env startAt: anIndex
				receiver: receiver]].
	^NativeResolver onBlock: resolveBlock withArguments: #(#(nil))! !

!SymbioticMessageTerm methodsFor: 'resolving' stamp: 'AndyKellens 11/2/2011 09:53'!
smalltalkMessageResolveWithKnownReceiverIn: env startAt: anIndex receiver: receiver
	
	| arguments result |
	arguments := (termsequence terms allButFirst: 1) asArray
		collect: [:term | term soulDownIn: env startAt: anIndex].
	self verifyMessageToBeSentTo: receiver.
	result := receiver
		perform: functor messageSelector
		withArguments: arguments.
	self verifyResultIsBoolean: result.
	^result
		ifTrue:
			[ResolutionResult
				condition: SoulFactory current makeTermSequence new
				rollbackInfo: env rollbackInfo
				conditionsEnvIndex: nil
				cutState: false]! !

!SymbioticMessageTerm methodsFor: 'resolving' stamp: 'sp 28/10/11 10:53'!
smalltalkMessageResolveWithUnknownReceiverIn: env startAt: anIndex
	
	self halt.
	self notYetImplemented! !

!SymbioticMessageTerm methodsFor: 'resolving' stamp: 'sp 28/10/11 10:53'!
verifyMessageToBeSentTo: receiver
	
	(receiver class canUnderstand: functor messageSelector)
		ifFalse:
			[self
				error:
					functor asString ,
							' is not implemented as a rule nor is understood as a message by instances of '
						, receiver class name asString]! !

!SymbioticMessageTerm methodsFor: 'resolving' stamp: 'AndyKellens 10/28/2011 17:07'!
verifyResultIsBoolean: result
	
	(result isKindOf: Boolean) 
		ifFalse:
			[self
				error:
					'predicate ' , functor asString ,
							' was sent as a message but answer was not a boolean']! !

SoulEvaluator subclass: #EvaluatorForSymbiosis
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-SmalltalkSymbiosis'!

!EvaluatorForSymbiosis class methodsFor: 'configuration' stamp: 'sp 28/10/11 10:53'!
associatedFactory
	
	^SymbiosisFactory! !

Object subclass: #FakeSingleItemCollection
	instanceVariableNames: 'item'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-SmalltalkSymbiosis'!

!FakeSingleItemCollection class methodsFor: 'instance creation' stamp: 'sp 28/10/11 10:53'!
on: anItem
	
	^(anItem isKindOf: Boolean)
		ifTrue:
			[anItem	"Because of an optimisation in the VM for booleans and ifTrue:ifFalse:, the FakeSingleItemCollection trick doesn't work well for booleans, so just return the boolean and hope the programmer doesnt want to send collection messages to it :)"
]
		ifFalse: [self new zzzOn: anItem]! !

!FakeSingleItemCollection methodsFor: 'collection faking' stamp: 'sp 28/10/11 10:53'!
allSatisfy: test
	
	^test value: item! !

!FakeSingleItemCollection methodsFor: 'collection faking' stamp: 'sp 28/10/11 10:53'!
at: idx
	
	^idx = 1
		ifTrue: [item]
		ifFalse: [self error: 'collection contains only one element']! !

!FakeSingleItemCollection methodsFor: 'collection faking' stamp: 'sp 28/10/11 10:53'!
do: aBlock
	
	aBlock value: item! !

!FakeSingleItemCollection methodsFor: 'message forwarding' stamp: 'AndyKellens 10/28/2011 13:43'!
doesNotUnderstand: aMessage
	^item
		perform: aMessage selector
		withArguments: aMessage arguments! !

!FakeSingleItemCollection methodsFor: 'collection faking' stamp: 'sp 28/10/11 10:53'!
first
	
	^item! !

!FakeSingleItemCollection methodsFor: 'initialization' stamp: 'sp 28/10/11 10:53'!
zzzOn: anItem
	
	item := anItem! !

Object subclass: #SymbiosisPreClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-SmalltalkSymbiosis'!

SymbiosisPreClass subclass: #SymbiosisClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-SmalltalkSymbiosis'!

!SymbiosisClass class methodsFor: 'compiler ' stamp: 'sp 28/10/11 10:53'!
compilerClass
	
	^SymbiosisCompiler! !

!SymbiosisClass methodsFor: 'as yet unclassified' stamp: 'AndyKellens 11/2/2011 09:53'!
doesNotUnderstand: message
	| queryText arguments counter results resultVariables |
	counter := 1.
	queryText := 'if ?self'.
	arguments := OrderedCollection with: #self -> self.
	resultVariables := Dictionary new.
	message selector numArgs > 0
		ifTrue: [ 
			message selector keywords
				do: [ :keyword | 
					queryText := queryText , ' ' , keyword asString , ' ?x' , counter asString.
					counter := counter + 1 ].
			message arguments
				keysAndValuesDo: [ :idx :arg | 
					(arg isKindOf: UninitializedTemporary)
						ifTrue: [ resultVariables at: 'x' , idx asString put: arg ]
						ifFalse: [ arguments add: ('x' , idx asString) asSymbol -> arg ] ] ]
		ifFalse: [ queryText := queryText , ' ' , message selector keywords first asString ].
	queryText := queryText , ' = ?result'.
	results := (SoulFactory current evaluatorForLogicQuery
		eval: queryText
		in: SoulFactory transparentSymbiosisRepository
		withAssociations: arguments) allResults.
	results success
		ifTrue: [ 
			resultVariables
				keysAndValuesDo: [ :queryVar :uninitSTVar | uninitSTVar become: (results downedResultsForVariableNamed: queryVar) ] ].
	^ results success
		ifTrue: [ results downedResultsForVariableNamed: 'result' ]
		ifFalse: [ false ]! !

Object subclass: #UninitializedTemporary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-SmalltalkSymbiosis'!

!UninitializedTemporary methodsFor: 'symbiosis' stamp: 'AndyKellens 11/2/2011 09:53'!
doesNotUnderstand: message
	
	| queryText arguments counter results resultVariables |
	counter := 1.
	queryText := 'if ?self'.
	arguments := OrderedCollection new.
	resultVariables := Dictionary new.
	resultVariables at: 'self' put: self.
	message selector numArgs > 0
		ifTrue:
			[message selector keywords
				do:
					[:keyword | 
					queryText := queryText , ' ' , keyword asString , ' ?x' , counter asString.
					counter := counter + 1].
			message arguments
				keysAndValuesDo:
					[:idx :arg | 
					(arg isKindOf: UninitializedTemporary)
						ifTrue:
							[resultVariables
								at: 'x' , idx asString
								put: arg]
						ifFalse: [arguments add: ('x' , idx asString) asSymbol -> arg]]]
		ifFalse:
			[queryText := queryText , ' ' , message selector keywords first asString].
	queryText := queryText , ' = ?result'.
	results := (SoulFactory current evaluatorForLogicQuery
		eval: queryText
		in: SoulFactory transparentSymbiosisRepository
		withAssociations: arguments) allResults.
	results success
		ifTrue:
			[resultVariables
				keysAndValuesDo:
					[:queryVar :uninitSTVar | uninitSTVar become: (results downedResultsForVariableNamed: queryVar)]].
	^results success
		ifTrue: [results downedResultsForVariableNamed: 'result']
		ifFalse: [false]! !
